using System;
using System.Collections.Generic;
using System.Text;
using StudentTrackingSystem.DataAccessLayer;
using StudentTrackingSystem.BusinessLayer;
using System.Data;
using System.Data.OleDb;

namespace StudentTrackingSystem.DataAccessLayer
{
    class DataLayer: BLclass
    {
        OleDbConnection conString = new OleDbConnection("provider=Microsoft.Jet.OLEDB.4.0;Data Source=BMSdb.mdb;");
        OleDbCommand cmd;
        OleDbDataAdapter adapter;
        OleDbDataReader reader;

        /*
         * This Function will call First Name of the Student in the 
         * Grid panel.
         * */

        public DataTable LoadStudentGrid()
        {
            DataSet dsStudents = new DataSet();
            try
            {
                conString.Open();
                cmd = new OleDbCommand("Select Firstname from studentdb", conString);
                adapter = new OleDbDataAdapter(cmd);
                adapter.Fill(dsStudents);
                dsStudents.Tables[0].Columns["Firstname"].ColumnName = "Student's Name";
                dsStudents.Tables[0].TableName = "Students";
                return dsStudents.Tables[0];
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                conString.Close();
                if (dsStudents != null)
                {
                    dsStudents.Dispose();
                }
            }
        }

        /*
   * This Function will call All the Data from the Student in the 
   * Grid panel.
   * */

        public DataTable LoadAllStudentGrid()
        {
            DataSet dsStudents = new DataSet();
            try
            {
                conString.Open();
                cmd = new OleDbCommand("Select * from studentdb", conString);
                adapter = new OleDbDataAdapter(cmd);
                adapter.Fill(dsStudents);
                //dsStudents.Tables[0].Columns["Firstname"].ColumnName = "Student's Name";
                //dsStudents.Tables[0].TableName = "Students";
                return dsStudents.Tables[0];
               // return dsStudents.Tables;
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                conString.Close();
                if (dsStudents != null)
                {
                    dsStudents.Dispose();
                }
            }
        }

        /*
         * This Function will call First Name of the Teacher in the 
         * Grid panel.
         * */

        public DataTable LoadTeacherGrid()
        {
            DataSet dsStudents = new DataSet();
            try
            {
                conString.Open();
                cmd = new OleDbCommand("Select Firstname from teacherdb", conString);
                adapter = new OleDbDataAdapter(cmd);
                adapter.Fill(dsStudents);
                dsStudents.Tables[0].Columns["Firstname"].ColumnName = "Teacher's Name";
                dsStudents.Tables[0].TableName = "Teacher";
                return dsStudents.Tables[0];
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                conString.Close();
                if (dsStudents != null)
                {
                    dsStudents.Dispose();
                }
            }
        }

        /*
          * This Function will call First Name of the Non-Tech in the 
          * Grid panel.
          * */

        public DataTable LoadNonTechGrid()
        {
            DataSet dsStudents = new DataSet();
            try
            {
                conString.Open();
                cmd = new OleDbCommand("Select Firstname from nontechdb", conString);
                adapter = new OleDbDataAdapter(cmd);
                adapter.Fill(dsStudents);
                dsStudents.Tables[0].Columns["Firstname"].ColumnName = "NonTech's Name";
                dsStudents.Tables[0].TableName = "NonTech";
                return dsStudents.Tables[0];
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                conString.Close();
                if (dsStudents != null)
                {
                    dsStudents.Dispose();
                }
            }
        }

        /*
         * This Function will set the Value of the Student in the 
         * BL Layer.
         * */

        public void SetValuetoStudentBL(string str)
        {
            try
            {
                conString.Open();
                cmd = new OleDbCommand("SELECT studentdb.FirstName, studentdb.Initial, studentdb.LastName,studentdb.BirthDay,studentdb.Person,studentdb.ContactNumber, studentdb.Address, studentdb.Sex,studentdb.Stream , studentdb.Mathematics ,studentdb.Physics, studentdb.Chemistry ,studentdb.Biology , studentdb.Batch, studentdb.EmailID , studentdb.RollNumber,studentdb.Photo FROM studentdb WHERE FirstName='" + str + "'", conString);
                //cmd = new OleDbCommand("select * from studentdb where FirstName = '" + str + "'", conString);
                reader = cmd.ExecuteReader();
                if (reader != null && reader.Read())
                {
                    FirstName = Convert.ToString(reader["Firstname"]);
                    MiddleInitial = Convert.ToString(reader["Initial"]);
                    LastName = Convert.ToString(reader["Lastname"]);
                    BirthDay = Convert.ToString(reader["birthday"]);
                    Person = Convert.ToString(reader["Person"]);
                    ContactNumber = Convert.ToString(reader["contactNumber"]);
                    Address = Convert.ToString(reader["Address"]);
                    Sex = Convert.ToString(reader["sex"]);
                    Stream = Convert.ToString(reader["stream"]);
                    Mathematics = Convert.ToString(reader["Mathematics"]);
                    Physics = Convert.ToString(reader["Physics"]);
                    Chemistry = Convert.ToString(reader["Chemistry"]);
                    Biology = Convert.ToString(reader["Biology"]);
                    Batch = Convert.ToString(reader["Batch"]);
                    EmailID = Convert.ToString(reader["EmailID"]);
                    Photo = Convert.ToString(reader["Photo"]);
                }
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                conString.Close();
                if (reader != null)
                {
                    reader.Dispose();
                }
            }
        }
                 /*
          * This Function will Save all the fields of students
          * 
          */
        public void SaveAll()
        {
            try
            {
                conString.Open();
                cmd = new OleDbCommand("INSERT INTO studentdb (FirstName,Initial, " + " LastName,BirthDay,Person,ContactNumber, " + " Address, Sex,Stream , " + " Mathematics ,Physics, Chemistry ,Biology , Batch, EmailID , " + "  RollNumber , " + " Photo ) VALUES ( '" +
                   FirstName + "','" + MiddleInitial + "','" + LastName + "','" + BirthDay + "','" + Person + "','" + ContactNumber + "','" + Address + "','" + Sex + "','" + Stream + "','" + Mathematics + "','" + Physics + "','" + Chemistry + "','" + Biology + "','" + Batch + "','" + EmailID + "','" + RollNumber + "','" + Photo + "')", conString);
                cmd.ExecuteNonQuery();
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                conString.Close();
            }
        }

        /*
         * This Function will Delete the records from database
         * 
         */

        public void DeleteValue(string str)
        {
            try
            {
                if (str != string.Empty)
                {
                    conString.Open();
                    cmd = new OleDbCommand("DELETE FROM studentdb WHERE FirstName='" + str + "'", conString);
                    cmd.ExecuteNonQuery();
                }
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                conString.Close();
            }
        }
        }
}
 
