using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using StudentTrackingSystem.DataAccessLayer;
using StudentTrackingSystem.BusinessLayer;


namespace StudentTrackingSystem
{
    public partial class StudentTrackingSystem : Form
    {
        public StudentTrackingSystem()
        {
            InitializeComponent();
        }
        #region Global Declaration
       // DataAccessLayer dlLayer;
        DataLayer dLayer = new DataLayer();
        #endregion

   /*
    *  This function Verify the Required field data 
    * while processing / Entering in the Form
    */

        private bool Verification()
        {
            if (txtFname.Text == string.Empty)
            {
                txtFname.Focus();
                string errorFname = "Please Provide First Name";
                errorPro.SetError(txtFname, errorFname);
                // MessageBox.Show("Please Provide First Name");
                return false;
            }
            if (txtContactNumber.Text == string.Empty)
            {
                txtContactNumber.Focus();
                string errorContactNumber = "Please Provide Contact Number";
                errorPro.SetError(txtContactNumber, errorContactNumber);
                return false;
            }
            if (txtSex.Text == string.Empty)
            {
                txtSex.Focus();
                string errorSex = "Please Choose Sex From Radio Button";
                errorPro.SetError(txtSex, errorSex);
                return false;
            }
            if (txtBatch.Text == string.Empty)
            {
                txtBatch.Focus();
                string errorBatch = "Please Choose Batch From Radio Button";
                errorPro.SetError(txtBatch, errorBatch);
                return false;
            }


            return true;
        }
        /*
         * This function will show when you click the data grid in the 
         * UI
         */
        private void MyGrid_MouseDown(object sender, MouseEventArgs e)
        {
            SetReadonly();
            System.Windows.Forms.DataGrid.HitTestInfo hit = MyGrid.HitTest(e.X, e.Y);
            if (hit.Row >= 0)
            {
                this.MyGrid.Select(hit.Row);
                string strID = MyGrid[hit.Row, 0].ToString();
                if (strID != string.Empty)
                {
                    dLayer.SetValuetoStudentBL(strID);
                    getValuefromStudentBL();
                    btnAddNew.Enabled = true;
                    btnDelete.Enabled = true;
                    btnSave.Enabled = false;
                }
            }
        }
        // Get teh Data Value from the student Business Layer
        private void getValuefromStudentBL()
        {
            txtFname.Text = dLayer.FirstName;
            txtInitial.Text = dLayer.MiddleInitial;
            txtLastName.Text = dLayer.LastName;
            dtBirthday.Text = dLayer.BirthDay;
            txtPerson.Text = dLayer.Person;
            txtContactNumber.Text = dLayer.ContactNumber;
            txtAddress.Text = dLayer.Address;
            txtSex.Text = dLayer.Sex;
            txtStream.Text = dLayer.Stream;
            txtMath.Text = dLayer.Mathematics;
            txtPhysics.Text = dLayer.Physics;
            txtChemistry.Text = dLayer.Chemistry;
            txtBiology.Text = dLayer.Biology;
            txtBatch.Text = dLayer.Batch;
            txtEmail.Text = dLayer.EmailID;
            txtPhoto.Text = dLayer.Photo;

        }

        private void txtFname_TextChanged(object sender, EventArgs e)
        {
            errorPro.Clear();

        }

        private void txtContactNumber_TextChanged(object sender, EventArgs e)
        {
            errorPro.Clear();

        }

        private void rdoMorning_CheckedChanged(object sender, EventArgs e)
        {
            if (rdoMorning.Checked == true && rdoEvening.Checked == false)
            {
                txtBatch.Text = rdoMorning.Text;
            }
            else
            {
                txtBatch.Text = rdoEvening.Text;
            }

        }

        private void rdoEvening_CheckedChanged(object sender, EventArgs e)
        {
            if (rdoMorning.Checked == false && rdoEvening.Checked == true)
            {
                txtBatch.Text = rdoEvening.Text;
            }
            else
            {
                txtBatch.Text = rdoMorning.Text;
            }

        }

        private void btnPhotoSelect_Click(object sender, EventArgs e)
        {
            openPhotoFileDialog.ShowDialog();

        }
        /*
 * This function Ensure that everything is in Read only mode ...
 * 
 */
        void SetReadonly()
        {
            txtFname.Enabled = false;
            txtInitial.Enabled = false;
            txtLastName.Enabled = false;
            dtBirthday.Enabled = false;
            txtPerson.Enabled = false;
            txtContactNumber.Enabled = false;
            txtAddress.Enabled = false;
            txtSex.Enabled = false;
            txtStream.Enabled = false;
            txtMath.Enabled = false;
            txtPhysics.Enabled = false;
            txtChemistry.Enabled = false;
            txtBiology.Enabled = false;
            txtBatch.Enabled = false;
            txtEmail.Enabled = false;
            txtRollNumber.Enabled = false;
            txtPhoto.Enabled = false;

            chkboxMath.Enabled = false;
            chkboxBiology.Enabled = false;
            chkboxPhysics.Enabled = false;
            chkboxChemistry.Enabled = false;

            pnlSex.Enabled = false;
            pnlBatch.Enabled = false;
            pnlStream.Enabled = false;

            btnGenerate.Enabled = false;
            btnPhotoSelect.Enabled = false;

        }
        /*
         * This function Ensure that everything is Not in  Read only mode i.e is           * in Normal Form ...
         * 
         */
        void SetNormalForm()
        {
            txtFname.Enabled = true;
            txtInitial.Enabled = true;
            txtLastName.Enabled = true;
            dtBirthday.Enabled = true;
            // txtPerson.Enabled = false;
            txtContactNumber.Enabled = true;
            txtAddress.Enabled = true;
            //txtSex.Enabled = false;
            //txtStream.Enabled = false;
            txtMath.Enabled = true;
            txtPhysics.Enabled = true;
            txtChemistry.Enabled = true;
            txtBiology.Enabled = true;
            //txtBatch.Enabled = false;
            txtEmail.Enabled = true;
            // txtRollNumber.Enabled = false;
            //  txtPhoto.Enabled = true;

            chkboxMath.Enabled = true;
            chkboxBiology.Enabled = true;
            chkboxPhysics.Enabled = true;
            chkboxChemistry.Enabled = true;

            pnlSex.Enabled = true;
            pnlBatch.Enabled = true;
            pnlStream.Enabled = true;

            btnGenerate.Enabled = true;
            btnPhotoSelect.Enabled = true;

        }

        private void StudentTrackingSystem_Load(object sender, EventArgs e)
        {

            SetReadonly();

            // The necessary stream should be active...

            rdoEnggineering.Enabled = true;
            rdoMedical.Enabled = true;

            // here the pnlEntry should be visible...
            pnlEntry.Visible = true;
            lblInfo.Visible = true;
            tableLayoutPanel1.Visible = true;
            lblInfo.Text = "Student Information Entry";

            txtPerson.Text = "Student";

            // Here the data will display and we can Add and Edit

            try
            {
                MyGrid.DataSource = dLayer.LoadStudentGrid();
                if (MyGrid.VisibleRowCount > 0)
                {
                    string strID = MyGrid[0, 0].ToString();
                    if (strID != string.Empty)
                    {
                        this.MyGrid.Select(0);
                        dLayer.SetValuetoStudentBL(strID);
                        getValuefromStudentBL();
                    }
                    btnAddNew.Enabled = true;
                    btnDelete.Enabled = true;
                    btnSave.Enabled = false;
                }
                else
                {
                    //  ClearAll();
                    btnAddNew.Enabled = true;
                    btnDelete.Enabled = false;
                    btnSave.Enabled = true;

                }
            }
            catch (Exception expMsg)
            {
                MessageBox.Show(expMsg.Message, "Student Information ...");
            }

        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            //ResetInfo();
            SetNormalForm();

            txtSex.Text = rdoMale.Text.ToString();
            txtStream.Text = rdoMedical.Text.ToString();
            txtBatch.Text = rdoMorning.Text.ToString();


            btnAddNew.Enabled = false;
            btnSave.Enabled = true;
            btnDelete.Enabled = false;
            txtFname.Focus();

        }

        private void btnSave_Click(object sender, EventArgs e)
        {
                        MyGrid.Refresh();
                        if (Verification())
                        {
                            dLayer.FirstName = txtFname.Text;
                            dLayer.MiddleInitial = txtInitial.Text;
                            dLayer.LastName = txtLastName.Text;
                            dLayer.BirthDay = dtBirthday.Text;
                            dLayer.Person = txtPerson.Text;
                            dLayer.ContactNumber = txtContactNumber.Text;
                            dLayer.Address = txtAddress.Text;
                            dLayer.Sex = txtSex.Text;
                            dLayer.Stream = txtStream.Text;
                            dLayer.Mathematics = txtMath.Text;
                            dLayer.Physics = txtPhysics.Text;
                            dLayer.Chemistry = txtChemistry.Text;
                            dLayer.Biology = txtBiology.Text;
                            dLayer.Batch = txtBatch.Text;
                            dLayer.EmailID = txtEmail.Text;
                            dLayer.Photo = txtPhoto.Text;

                            dLayer.SaveAll();
                            StudentTrackingSystem_Load(sender, e);
                            btnSave.Enabled = false;
                            btnAddNew.Enabled = true;
                            btnDelete.Enabled = true;
                        }
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            //ask user if wanting to delete
            DialogResult dr = MessageBox.Show("Are you sure you want to delete this Record ? ", "Confirm deleting", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (dr == DialogResult.Yes)
            {
                if (MyGrid.CurrentRowIndex >= 0)
                {
                    this.MyGrid.Select(MyGrid.CurrentRowIndex);
                    string strID = MyGrid[MyGrid.CurrentRowIndex, 0].ToString();
                    if (strID != string.Empty)
                    {
                        dLayer.DeleteValue(strID);
                        MessageBox.Show("Successfully deleted the Record. ", "Sucessful deletion", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        StudentTrackingSystem_Load(sender, e);
                    }
                }
            }
        }

    }
}